import logging
try:
    import kerberos
    have_kerberos = True
except:
    have_kerberos = False
    
log = logging.getLogger("cumin.kerbauth")
    

class CuminAuthenticatorKerberos(object):
    def __init__(self, mech, app):
        log.info("Initializing %s", self)
        self.kerb_realm = app.kerberos_realm
        if (self.kerb_realm is not None and self.kerb_realm is not ""):
            self.valid = True
        else:
            self.valid = False
            log.info("Required values for kerberos_server and kerberos_realm not set")
        
    def authenticate(self, username, password):
        log.debug("Authenticating for user %s against %s" % (username, self.__class__.__name__))
        isAuth = False
        if self.valid:
            try:
                isAuth = kerberos.checkPassword(username, password, "HTTP", self.kerb_realm)
            except Exception, e:
                log.debug("Auth failed %s" % e)
        else:
            log.error("Kerberos authentication failed due to an invalid kerberos server/realm config")
        return isAuth  
    
    def find_user(self, username):
        return False

    @staticmethod
    def isKerbAvail():
        return have_kerberos